<!DOCTYPE html>
<html lang="en">

<head>

    <title>Task 23b.40</title>
    <meta charset='utf-8'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <style>
        .picture-cover {
            background-image: url("cover.jpg");
            min-height: 100px;
            margin: 5px;
        }
    </style>
</head>

<body>
    <div class="container-fluid  picture-cover">
    </div>
    <div class="container">
        <div class="row ">
            <div class="col-5">
                <div class="row  form-group">
                    <div class="col-12">
                        <h4>Nhập thông tin chủa bạn</h4>
                    </div>
                </div>
                <div class="row ">
                    <div class="col-4">
                        <label>Username</label>
                    </div>
                    <div class="col-8 ">
                        <input type="text" id="input-username" class="form-control">
                    </div>
                </div>
                <div class="row ">
                    <div class="col-4">
                        <label>Firstname</label>
                    </div>
                    <div class="col-8 ">
                        <input type="text" id="input-firstname" class="form-control">
                    </div>
                </div>
                <div class="row ">
                    <div class="col-4">
                        <label>Lastname</label>
                    </div>
                    <div class="col-8 ">
                        <input type="text" id="input-lastname" class="form-control">
                    </div>
                </div>
            </div>
            <div class="col-4 ">
                <div class="row text-center">
                    <div class="col-12 ß">
                        <input type="button" id="btn-dice" class="btn btn-secondary button-width w-75" value="Ném"
                            onclick="onBtnNemClick()">
                    </div>
                </div>
                <div class="row">
                    <div class="col-12 ">
                        <img src="dice.png" id="img-dice" class="img-thumbnail">
                    </div>
                </div>
                <div class="row text-center">
                    <div class="col-12 ">
                        <p id="p-notification-dice" style="color: blue;">Chúc mừng</p>
                    </div>
                </div>
            </div>
            <div class="col-3 ">
                <div class="row form-group">
                    <div class="col-12 ">
                        <p>Voucher</p>
                        <p id="p-voucher-id">No ID</p>
                        <p id="p-voucher-percent">0%</p>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12 ">
                        <img src="xe-may.jpg" class="img-thumbnail" id="img-present">
                    </div>
                </div>
            </div>
        </div>
        <div class="row  text-center form-group">
            <div class="col-12">
                <button id="btn-dice-history" class="btn btn-info button-width w-25" onclick="onBtnDicecHistory()">Dice
                    History</button>
                <button id="btn-voucher-history" class="btn btn-success button-width w-25" onclick="onBtnVoucherHistory()">Voucher History</button>
                <button id="btn-present-history" class="btn btn-warning button-width w-25" onclick="onBtnPresentHistory()">Present History</button>
            </div>
        </div>
        <div class="row  ">
            <div class="col-12">
                <div class="col-12">
                    <table id="history-table" class="table table-striped table-hover border">
                        <thead>
                            
                        </thead>
                        <tbody>

                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
</body>
<script>
    /*** REGION 1 - Global variables */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice/";
    const gUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
    const gEND_OF_ROW_COL = -1;
    const gCOLUMN_GAME = 0;
    const gCOLUMN_VALUE = 1;
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onBtnNemClick() {
        var vUserObj = {
            username: "",
            firstname: "",
            lastname: ""
        };
        thuThapDuLieu(vUserObj);
        var vHopLe = kiemTraDuLieu(vUserObj);
        if (vHopLe) {
            var vXmlHttpDice = new XMLHttpRequest();
            callApiDice(vUserObj, vXmlHttpDice)
            vXmlHttpDice.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    hienThiKetQua(vXmlHttpDice);
                }
            }
        }
    }

    function onBtnDicecHistory() {
        var vUserObj = {
            username: ""
        };
        thuThapDuLieuHistory(vUserObj);
        var vHopLe = kiemTraDuLieuHistory(vUserObj);
        if (vHopLe) {
            var vXmlHttpDice = new XMLHttpRequest();
            callApiDiceHistory(vUserObj, vXmlHttpDice)
            vXmlHttpDice.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    showDiceHistoryTable(vXmlHttpDice);
                }
            }
        }
    }

    function onBtnVoucherHistory() {
        var vUserObj = {
            username: ""
        };
        thuThapDuLieuHistory(vUserObj);
        var vHopLe = kiemTraDuLieuHistory(vUserObj);
        if (vHopLe) {
            var vXmlHttpDice = new XMLHttpRequest();
            callApiVoucherHistory(vUserObj, vXmlHttpDice)
            vXmlHttpDice.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    showVoucherHistoryTable(vXmlHttpDice);
                }
            }
        }
    }

    function onBtnPresentHistory() {


    }
    /*** REGION 4 - Common funtions */
    function thuThapDuLieu(paramUser) {
        var vInpUsername = document.getElementById("input-username");
        var vInpFirstname = document.getElementById("input-firstname");
        var vInpLastname = document.getElementById("input-lastname");

        paramUser.username = vInpUsername.value.trim();
        paramUser.firstname = vInpFirstname.value.trim();
        paramUser.lastname = vInpLastname.value.trim();
    }

    function kiemTraDuLieu(paramUser) {
        if (paramUser.username == "") {
            alert("Cần nhập username!");
            return false;
        }
        if (paramUser.firstname == "") {
            alert("Cần nhập firstname!");
            return false;
        }
        if (paramUser.lastname == "") {
            alert("Cần nhập lastname!");
            return false;
        }
        return true;
    }

    function callApiDice(paramUser, paramXHTML) {
        paramXHTML.open("POST", gBASE_URL + "/dice", true);
        paramXHTML.setRequestHeader("Content-Type", gUTF8_TEXT_APPLICATION_HEADER);
        paramXHTML.send(JSON.stringify(paramUser));
    }

    function hienThiKetQua(paramXHTML) {
        "use strict";
        //console.log(paramXHTML.responseText);

        var vResponseToObj = JSON.parse(paramXHTML.responseText);
        console.log(vResponseToObj);

        var vDice = vResponseToObj.dice;
        console.log("result: " + vDice);

        changeDice(vDice);
        changeNotification(vDice);
        changeVoucherId(vResponseToObj);
        changePrize(vResponseToObj);
    }

    function changeDice(paramDice) {
        var vImgDice = document.getElementById("img-dice");
        switch (paramDice) {
            case 1:
                vImgDice.src = "1.png";
                break;
            case 2:
                vImgDice.src = "2.png";
                break;
            case 3:
                vImgDice.src = "3.png";
                break;
            case 4:
                vImgDice.src = "4.png";
                break;
            case 5:
                vImgDice.src = "5.png";
                break;
            case 6:
                vImgDice.src = "6.png";
                break;
            default:
                vImgDice.src = "dice.png";
        }
    }

    function changeNotification(paramDice) {
        var vNotification = document.getElementById("p-notification-dice");
        if (paramDice < 4) {
            vNotification.innerHTML = "Chúc bạn may mắn lần sau!";
        } else {
            vNotification.innerHTML = "Chúc mừng bạn hãy chơi tiếp lần nữa!";
        }
    }

    function changeVoucherId(paramVoucher) {
        var vVoucherId = document.getElementById("p-voucher-id");
        var vVoucherPercent = document.getElementById("p-voucher-percent");

        if (paramVoucher.voucher != null) {
            vVoucherId.innerHTML = paramVoucher.voucher.id;
            vVoucherPercent.innerHTML = paramVoucher.voucher.phanTramGiamGia + "%";
        } else {
            vVoucherId.innerHTML = "";
            vVoucherPercent.innerHTML = "";
        }
    }

    function changePrize(paramPresent) {
        var vImgPrize = document.getElementById("img-present");
        switch (paramPresent.prize) {
            case "Mũ":
                vImgPrize.src = "hat.jpg";
                break;
            case "Áo mưa":
                vImgPrize.src = "ao-mua.jpg";
                break;
            case "Xe máy":
                vImgPrize.src = "xe-may.jpg";
                break;
            case "Sổ":
                vImgPrize.src = "book.jpg";
                break;
            case "Ô tô":
                vImgPrize.src = "car.jpg";
                break;
            case "Áo":
                vImgPrize.src = "t-shirt.jpg";
                break;
            default:
                vImgPrize.src = "no-present.jpg";
                break;
        }
    }

    function thuThapDuLieuHistory(paramUser) {
        var vInpUsername = document.getElementById("input-username");

        paramUser.username = vInpUsername.value;
    }

    function kiemTraDuLieuHistory(paramUser) {
        if (paramUser.username == "") {
            alert("Cần nhập username!");
            return false;
        }
        return true;
    }

    function callApiDiceHistory(paramUser, paramXHTML) {
        paramXHTML.open("GET", gBASE_URL + "/dice-history?username=", true);
        paramXHTML.send();
    }

    function showDiceHistoryTable(paramXmlHttp) {
        //console.log(paramXmlHttp.responseText);
        var vDiceHistory = JSON.parse(paramXmlHttp.responseText);
        var vDiceTable = document.getElementById("history-table");
        var vTableHeader = vDiceTable.getElementsByTagName("thead")[0];
        var vTableBody = vDiceTable.getElementsByTagName("tbody")[0];

        var bNewRowHeader = vTableHeader.insertRow(gEND_OF_ROW_COL);

        var bGameCellTitle = bNewRowHeader.insertCell(gCOLUMN_GAME);
        var vDiceCellTitle = bNewRowHeader.insertCell(gCOLUMN_VALUE);

        bGameCellTitle.innerHTML = "Lượt";
        vDiceCellTitle.innerHTML = "Dice";

        for (var bI = 0; bI < vDiceHistory.dices.length; bI++) {
            //thêm dòng
            var bNewRow = vTableBody.insertRow(gEND_OF_ROW_COL);
            //thêm cột
            var bGameCell = bNewRow.insertCell(gCOLUMN_GAME);
            var bDiceCell = bNewRow.insertCell(gCOLUMN_VALUE);

            bGameCell.innerHTML = bI + 1;
            bDiceCell.innerHTML = vDiceHistory.dices[bI];
        }
    }

    function callApiVoucherHistory(paramUser, paramXHTML){
        paramXHTML.open("GET", gBASE_URL + "/voucher-history?username=", true);
        paramXHTML.send();
    }

    function showVoucherHistoryTable(paramXmlHttp){
        console.log(paramXmlHttp.responseText);
        var vVoucherHistory = JSON.parse(paramXmlHttp.responseText);
        var vVoucherTable = document.getElementById("history-table");
        var vTableHeader = vVoucherTable.getElementsByTagName("thead")[0];
        var vTableBody = vVoucherTable.getElementsByTagName("tbody")[0];

        var bNewRowHeader = vTableHeader.insertRow(gEND_OF_ROW_COL);

        var bVoucherIDCellTitle = bNewRowHeader.insertCell(gCOLUMN_GAME);
        var vVoucherCoedCellTitle = bNewRowHeader.insertCell(gCOLUMN_VALUE);

        bVoucherIDCellTitle.innerHTML = "Voucher ID";
        vVoucherCoedCellTitle.innerHTML = "Voucher Code";

        for (var bI = 0; bI < vVoucherHistory.vouchers.length; bI++) {
            //thêm dòng
            var bNewRow = vTableBody.insertRow(gEND_OF_ROW_COL);
            //thêm cột
            var bGameCell = bNewRow.insertCell(gCOLUMN_GAME);
            var bDiceCell = bNewRow.insertCell(gCOLUMN_VALUE);

            bGameCell.innerHTML = vVoucherHistory.vouchers[bI].id;
            bDiceCell.innerHTML = vVoucherHistory.vouchers[bI].maVoucher;
        }
    }
</script>

</html>